open ExtLib
open Commons
 
module ParSimp = Osm_parser.Parser(Geo_simple);;
module ParComp1 = Osm_parser.Parser(Geo_complete.FirstPass)
module ParComp2 = Osm_parser.Parser(Geo_complete.SecondPass)

let clip_osm_simple osm_fname poly_fname result_fname =
	Poly.prepare poly_fname;
	Geo_base.create_outfile result_fname; 
	let lexbuf, ic = Geo_base.open_osm osm_fname in
	ParSimp.osmfile Osm_lexer.lexer lexbuf;
	close_in ic;
	Geo_base.close_outfile ();
	print_endline "Simple clipping done."

let clip_osm_complete osm_fname poly_fname result_fname =
	Poly.prepare poly_fname;
	let lexbuf, ic = Geo_base.open_osm osm_fname in
	ParComp1.osmfile Osm_lexer.lexer lexbuf;
	close_in ic;
	Geo_base.create_outfile result_fname;
	let lexbuf, ic = Geo_base.open_osm osm_fname in
	ParComp2.osmfile Osm_lexer.lexer lexbuf;
	close_in ic;	 
	Geo_base.close_outfile ();
	print_endline "Clipping with complete objects done.";;
	
match Array.length Sys.argv with
	| 4 -> clip_osm_simple Sys.argv.(1) Sys.argv.(2) Sys.argv.(3) (*"simple2.osm" "simple2.poly" "out-simple2.osm"*)
	| 5 -> clip_osm_complete Sys.argv.(1) Sys.argv.(2) Sys.argv.(3) (*"simple2.osm" "simple2.poly" "out-simple2.osm"*)
	| _ -> print_endline "Usage: osm in.osm in.poly out.osm [complete]";;
        
  